\tikzstyle{ast} = [circle,draw=gt@alum-6,fill=gt@alum-1]
\tikzstyle{module} = [draw,text width=8em]
\tikzstyle{connection} = [<->, thick]

\begin{tikzpicture}[sibling distance=2em, level distance=1.25em]

  \node (argot) {Argot Server};
  \node [ast, below=1.25em of argot] (asts) {}
  child { node [ast] (asts-left) {}}
  child { node [ast] {} {
      child { node [ast] {}{
          child { node [ast] {}}
          child { node [ast] {} {
              child { node [ast] (asts-bottom) {}}}}}}
      child { node [ast] (asts-right) {}}}};
  \node[circle, draw, fit=(argot) (asts) (asts-bottom) (asts-right) (asts-left)] (server) {};

  \node[above left=1em and 6em of server.north west] (ltools) {Argot Modules};
  \node[module, below=1em of ltools] (lm1) {\ldots{}};
  \node[module, below=1em of    lm1] (lm2) {IDE};
  \node[module, below=1em of    lm2] (lm3) {\ldots{}};
  \node[module, below=1em of    lm3] (lm4) {Test Synthesis};
  \node[module, below=1em of    lm4] (lm5) {\ldots{}};

  \node[above right=1em and 6em of server.north east] (tools) {Argot Modules};
  \node[module, below=1em of tools] (m1) {\ldots{}};
  \node[module, below=1em of    m1] (m2) {Type Synthesis};
  \node[module, below=1em of    m2] (m3) {\ldots{}};
  \node[module, below=1em of    m3] (m4) {Code Synthesis};
  \node[module, below=1em of    m4] (m5) {\ldots{}};

  %% \node[inner sep=1em, draw, below=4em of server, text width=10em, text centered] (lsp) {Standard LSP servers};

  %% Connections
  \draw[connection] (server) to node[midway, above, sloped] {Argot} (lm1.east);
  \draw[connection] (server) to (lm2.east);
  \draw[connection] (server) to (lm3.east);
  \draw[connection] (server) to (lm4.east);
  \draw[connection] (server) to node[midway, below, sloped] {LSP} (lm5.east);

  \draw[connection] (server) to node[midway, above, sloped] {Argot} (m1.west);
  \draw[connection] (server) to (m2.west);
  \draw[connection] (server) to (m3.west);
  \draw[connection] (server) to (m4.west);
  \draw[connection] (server) to node[midway, below, sloped] {LSP} (m5.west);

  %% \draw[connection] (server) to node[auto,right] {LSP passthrough} (lsp);

\end{tikzpicture}
